<template>
  <section class="c-form-condition-wrap" :class="error ? 'error' : ''">
    <div class="c-form-condition">
      <div class="c-form-condition__text">
        <Paragraph :text="title" weight="semibold" color="secondary" />
        <Paragraph v-if="description" :text="description" color="secondary" />
      </div>
      <div v-show="!isPreview" class="c-form-condition__action">
        <label
          v-for="radio in options"
          :key="radio.value"
          :for="`${radio.label}-${id}`"
          class="c-form-condition__radio"
          :class="[
            value === radio.value ? 'active' : '',
            disabledRadio && disabledRadio === radio.value ? 'disabled' : ''
          ]"
        >
          {{ radio.label }}
          <input
            :id="`${radio.label}-${id}`"
            type="radio"
            :name="id"
            :value="radio.value"
            @click="e => changeInputHandler(e)"
            :checked="value === radio.value"
            :disabled="disabledRadio ? disabledRadio === radio.value : false"
          />
        </label>
      </div>

      <div
        v-if="isPreview"
        :class="`c-form-condition__preview c-form-condition__preview--${value}`"
      >
        <i :class="`icon icon--${previewIconHandler()}`" />
        {{ value }}
      </div>
    </div>
    <ErrorMessage v-if="error" :text="error" align="right" />
    <PopupConfirmation
      v-if="popup && isPopupVisible"
      :title="popup.title"
      :descriptions="popup.description"
      :buttonText="popup.buttonText"
      @close="setPopup(false)"
      @clicked="popupConfirmHandler"
    />
  </section>
</template>

<script>
import Paragraph from "@/components/ui/Paragraph";
import ErrorMessage from "../ErrorMessage";
import { isPreviewMixin } from "../../mixins/isPreview";
import PopupConfirmation from "../PopupConfirmation";
export default {
  name: "FormCondition",
  components: { PopupConfirmation, ErrorMessage, Paragraph },
  mixins: [isPreviewMixin],
  props: {
    id: {
      type: String,
      required: true
    },
    title: {
      type: String,
      required: true
    },
    description: String,
    error: String,
    disabledRadio: String,
    value: {
      type: String,
      required: true
    },
    model: {
      prop: "value",
      event: "input"
    },
    popup: [Object, undefined]
  },
  data: function() {
    return {
      options: [
        {
          label: "Yes",
          value: "yes"
        },
        {
          label: "No",
          value: "no"
        }
      ],
      isPopupVisible: false
    };
  },
  methods: {
    changeInputHandler(e) {
      const { value } = e.target;

      if (this.value === value) return; // Prevent clicking on active item

      if (this.popup && value === this.popup.condition) {
        this.setPopup(true);
      } else {
        this.$emit("input", value);
      }
    },
    previewIconHandler() {
      switch (this.value) {
        case "no":
          return "close";
        case "yes":
          return "check";

        default:
          return "";
      }
    },
    popupConfirmHandler() {
      this.$emit("input", this.popup.condition);
      this.setPopup(false);
    },
    setPopup(value) {
      this.isPopupVisible = value;
    }
  }
};
</script>

<style lang="scss">
.c-form-condition-wrap {
  margin-bottom: 2.5rem;
  &.error {
    .c-form-condition__radio {
      border-color: $c-error;
    }
  }
}
.c-form-condition {
  background-color: $c-brand-primary;
  border: 1px solid $c-brand-primary;
  padding: 2rem 1rem;

  @include breakpoint(overPhone) {
    display: flex;
    justify-content: space-between;
    padding: 1.3rem 1.5rem 1.3rem 2.5rem;
  }

  &__text {
    @include breakpoint(phone) {
      text-align: center;
    }
    @include breakpoint(overPhone) {
      padding-right: 5%;
      margin-top: 0.5rem;
    }
  }

  &__action {
    display: flex;
    justify-content: center;
    margin: 3rem 0 2rem;
    @include breakpoint(overPhone) {
      margin: 0;
    }
  }

  &__radio {
    display: flex;
    justify-content: center;
    align-items: center;
    font-size: 1.6rem;
    line-height: 2.4rem;
    text-align: center;
    width: 10rem;
    height: 3.8rem;
    color: $c-white;
    border: 1px solid $c-white;
    border-right: none;
    transition: 0.3s;
    cursor: pointer;

    @include breakpoint(overPhone) {
      width: 8rem;
    }

    &:last-of-type {
      border: 1px solid $c-white;
    }

    &.active {
      background-color: $c-white;
      color: $c-brand-primary;
    }

    &.disabled {
      cursor: not-allowed;
    }

    input {
      width: 0;
      height: 0;
    }
  }

  &__preview {
    display: flex;
    align-items: center;
    font-size: 1.6rem;
    text-transform: capitalize;

    @include breakpoint(phone) {
      justify-content: center;
      margin: 3rem 0 2rem;
    }

    @include breakpoint(overPhone) {
      margin-right: 2rem;
    }

    &--yes {
      color: $c-success;
    }

    &--no {
      color: $c-error;
    }

    .icon {
      margin-right: 1rem;
    }
  }

  .c-paragraph {
    &:last-of-type {
      @include breakpoint(overPhone) {
        margin-bottom: 0.5rem;
      }
    }
  }
}
</style>
